importScripts('https://www.gstatic.com/firebasejs/5.0.4/firebase-app.js');
importScripts('https://www.gstatic.com/firebasejs/5.0.4/firebase-messaging.js');
firebase.initializeApp({
    'messagingSenderId': '780057141561'
});
const messaging = firebase.messaging();
messaging.setBackgroundMessageHandler(function (payload) {
    var key = payload.data.loc_key;
    var args = JSON.parse(payload.data.loc_args);
    var title, message;
    switch (key) {
        case 'MESSAGE_TEXT':
            title = args[0];
            message = args[1];
            break;
        case 'MESSAGE_IMAGE':
            title = args[0];
            message = 'sent you a photo';
            break;
        case 'MESSAGE_VIDEO':
            title = args[0];
            message = 'sent you a video';
            break;
        case 'MESSAGE_AUDIO':
            title = args[0];
            message = 'sent you a audio';
            break;
        case 'MESSAGE_VOICE':
            title = args[0];
            message = 'sent you a voice message';
            break;
        case 'MESSAGE_GIF':
            title = args[0];
            message = 'sent you a gif';
            break;
        case 'MESSAGE_FILE':
            title = args[0];
            message = 'sent you a file';
            break;
        case 'MESSAGE_LOCATION':
            title = args[0];
            message = 'sent you a location';
            break;
        case 'MESSAGE_CONTACT':
            title = args[0];
            message = 'shared a contact with you';
            break;
        case 'GROUP_MESSAGE_TEXT':
            title = args[0] + '@' + args[1];
            message = args[2];
            break;
        case 'GROUP_MESSAGE_IMAGE':
            title = args[0];
            message = 'sent a photo to the group ' + args[1];
            break;
        case 'GROUP_MESSAGE_VIDEO':
            title = args[0];
            message = 'sent a video to the group ' + args[1];
            break;
        case 'GROUP_MESSAGE_AUDIO':
            title = args[0];
            message = 'sent a audio to the group ' + args[1];
            break;
        case 'GROUP_MESSAGE_VOICE':
            title = args[0];
            message = 'sent a voice message to the group ' + args[1];
            break;
        case 'GROUP_MESSAGE_GIF':
            title = args[0];
            message = 'sent a gif to the group ' + args[1];
            break;
        case 'GROUP_MESSAGE_FILE':
            title = args[0];
            message = 'sent a file to the group ' + args[1];
            break;
        case 'GROUP_MESSAGE_LOCATION':
            title = args[0];
            message = 'sent a location to the group ' + args[1];
            break;
        case 'GROUP_MESSAGE_CONTACT':
            title = args[0];
            message = 'shared a contact with you in the group ' + args[1];
            break;
        case 'CHANNEL_MESSAGE_TEXT':
            title = args[0];
            message = args[1];
            break;
        case 'CHANNEL_MESSAGE_IMAGE':
            title = args[0];
            message = 'posted a photo';
            break;
        case 'CHANNEL_MESSAGE_VIDEO':
            title = args[0];
            message = 'posted a video';
            break;
        case 'CHANNEL_MESSAGE_AUDIO':
            title = args[0];
            message = 'posted a audio';
            break;
        case 'CHANNEL_MESSAGE_VOICE':
            title = args[0];
            message = 'posted a voice message';
            break;
        case 'CHANNEL_MESSAGE_GIF':
            title = args[0];
            message = 'posted a gif';
            break;
        case 'CHANNEL_MESSAGE_FILE':
            title = args[0];
            message = 'posted a file';
            break;
        case 'CHANNEL_MESSAGE_LOCATION':
            title = args[0];
            message = 'posted a location';
            break;
        case 'CHANNEL_MESSAGE_CONTACT':
            title = args[0];
            message = 'posted a contact';
            break;
    }
    var notificationOptions = {
        body: message,
        icon: 'https://web.igap.net/favicon/favicon-96x96.png'
    };
    return self.registration.showNotification(
        title,
        notificationOptions
    );
});
self.addEventListener('notificationclick', function (event) {
    const urlToOpen = new URL('https://web.igap.net', self.location.origin).href;
    const promiseChain = clients.matchAll({
        type: 'window',
        includeUncontrolled: true
    }).then(function (windowClients) {
        var matchingClient = null;
        for (var i = 0; i < windowClients.length; i++) {
            const windowClient = windowClients[i];
            if (windowClient.url.search(urlToOpen) >= 0) {
                matchingClient = windowClient;
                break;
            }
        }
        if (matchingClient) {
            return matchingClient.focus();
        } else {
            return clients.openWindow(urlToOpen);
        }
    });
    event.waitUntil(promiseChain);
});
